Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 231444 - dhclient broken in Xen guest - need xen-checksum patch
Summary: dhclient broken in Xen guest - need xen-checksum patch
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: dhcp
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: David Cantrell
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2007-03-08 12:25 UTC by Mark McLoughlin
Modified: 2007-11-30 22:11 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2007-04-11 14:30:13 UTC


Attachments (Terms of Use)
linux-2.6.19-packet-auxdata-csum.patch (deleted)
2007-03-08 12:28 UTC, Mark McLoughlin
no flags Details | Diff
dhcp-3.0.5-xen-checksum.patch (deleted)
2007-03-08 12:28 UTC, Mark McLoughlin
no flags Details | Diff
dhcp-3.0.5-xen-checksum.patch (deleted)
2007-04-11 14:16 UTC, David Cantrell
no flags Details | Diff

Description Mark McLoughlin 2007-03-08 12:25:46 UTC
kernel-xen-2.6.19-1.2898.2.3.fc7
dhclient-3.0.5-25.2.fc7

Basically, running dhclient in a Xen guest, dhclient is ignoring DHCP relies and
I'm seeing this in syslog:

Mar  7 12:11:29 localhost dhclient: 5 bad udp checksums in 5 packets

The background to this is that packets from Xen guests on the same host only
have partial checksums. (Not sure why)

In rh #219681, Herbert proposed a set of patches to fix this - first make the
TP_STATUS_CSUMNOTREADY flag available via recvmsg() auxdata and, second, make
dhclient check this flag and ignore the checksums if its set.

These patches aren't in rawhide, but I've tried applying the patches and it
seems dhclient isn't seeing the replies at all now - i.e. I'm seeing this in the
strace:

select(7, [5 6], [], [], {7, 996967})   = 0 (Timeout)
gettimeofday({1173356524, 521}, NULL)   = 0
time([1173356524])                      = 1173356524
stat("/etc/localtime", {st_mode=S_IFREG|0644, st_size=3533, ...}) = 0
stat("/etc/localtime", {st_mode=S_IFREG|0644, st_size=3533, ...}) = 0
stat("/etc/localtime", {st_mode=S_IFREG|0644, st_size=3533, ...}) = 0
sendto(3, "<30>Mar  8 12:22:04 dhclient: DH"..., 89, MSG_NOSIGNAL, NULL, 0) = 89
write(2, "DHCPDISCOVER on eth0 to 255.255."..., 59) = 59
write(2, "\n", 1)                       = 1
write(6, "\377\377\377\377\377\377\0\26>l\5\0\10\0E\20\1H\0\0\0\0"..., 342) = 342
gettimeofday({1173356524, 1094}, NULL)  = 0
select(7, [5 6], [], [], {11, 998906})  = 0 (Timeout)



Attaching the patches as I've built them.

Comment 1 Mark McLoughlin 2007-03-08 12:28:04 UTC
Created attachment 149561 [details]
linux-2.6.19-packet-auxdata-csum.patch

Comment 2 Mark McLoughlin 2007-03-08 12:28:58 UTC
Created attachment 149562 [details]
dhcp-3.0.5-xen-checksum.patch

Comment 3 Mark McLoughlin 2007-03-08 12:35:30 UTC
(Sorry, bug #219681 is the link to the RHEL5 bug)

Comment 4 Mark McLoughlin 2007-04-11 14:07:09 UTC
Okay, linux-2.6-xen.patch in rawhide kernel-xen-2.6.20-2925.5.fc7 has Herbert's
original patch and his subsequent fix, both of which were sent upstream here:

  http://www.mail-archive.com/netdev@vger.kernel.org/msg29299.html

So, what's needed is the xen-checksum patch which was removed from rawhide.
Moving to dhcp.


Comment 5 David Cantrell 2007-04-11 14:16:04 UTC
Created attachment 152271 [details]
dhcp-3.0.5-xen-checksum.patch

Comment 6 Mark McLoughlin 2007-04-11 14:29:12 UTC
Both dhcp-3.0.5-xen-checksum.patch patches are identical, both fix the problem
with rawhide kernel and dhclient

Comment 7 David Cantrell 2007-04-11 14:30:13 UTC
Patch applied to dhcp-3.0.5-30.fc7 in rawhide.  Thanks.


Note You need to log in before you can comment on or make changes to this bug.